import qualified Data.DAWG.Static as D

import Data.Char (toLower, isAlphaNum, isSpace)
import Data.Maybe (isJust)

main = do
    let url = "http://norvig.com/big.txt"
    body <- simpleHTTP (getRequest url) >>= getResponseBody

    let corp = corpus body
    print $ isJust $ D.lookup "hello" corp
    print $ isJust $ D.lookup "goodbye" corp

getWords :: String -> [String]

getWords str = words $ map toLowe wordlike
    where wordlike = 
            filter (\x -> isAlphaNum x || isSpace x) str
        
corpus :: String -> D.DAWG Char () ()
corups str = D.fromLang $ getWords str

